<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des modes d'hébergement n'ont pas pu être chargées."
    />
    <template v-else-if="accommodationModesCounts">
      <h2 class="fr-h5">Modes d'hébergement</h2>
      <StatsList
        v-if="accommodationModesCounts.length"
        :total-count="beneficiaryCount"
        :stats="accommodationModesCounts"
        stats-bar
      />
      <p v-else>
        Commencez à
        <NuxtLink
          :to="Routes.BeneficiariesAdd"
          target="_self"
          >créer des fiches de bénéficiaires</NuxtLink
        >
        pour voir apparaître les statistiques de la répartition des modes
        d'hébergement.
      </p>
    </template>
  </div>
</template>

<script setup>
  import { ACCOMMODATION_MODE_OPTIONS } from '~/utils/constants/beneficiary'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { labelOrUnprovided } from '~/utils/stats'
  import { Routes } from '~/utils/routing/routes'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    beneficiaryCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: accommodationModesCounts,
    pending,
    error,
    refresh
  } = useLazyAsyncData(
    'accommodationModesCounts',
    loadAccommodationModesCounts,
    {
      server: false
    }
  )

  watch(() => props.filters, refresh)

  async function loadAccommodationModesCounts() {
    const res = await $getItems('beneficiary', {
      groupBy: 'accommodation_mode',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const accommodationModesResCounts = res.data.data.map(
        accommodationMode => ({
          key: accommodationMode.accommodation_mode,
          label: labelOrUnprovided(
            accommodationMode.accommodation_mode,
            ACCOMMODATION_MODE_OPTIONS
          ),
          count: parseInt(accommodationMode.countDistinct.id)
        })
      )
      accommodationModesResCounts.sort((a, b) => b.count - a.count)
      return accommodationModesResCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
